# Plugin inspired by Server Hop
# Instead of a menu, you use chat commands, this allow users to have both installed if they want.
# > annouce_server is needed, so this might cause a little spam in chat if you have [hop] and [Redirect] on your server.
#
# This plugin is provided by chat commands <>
# My Website:www.zeekzone.tk
#

# < Modules >
import es
import msglib
import gamethread
import datetime
import msglib
import cfglib
import popuplib
import urllib2

info = es.AddonInfo()
info.author      = "ZZMatty"
info.name        = "Server Redirect"
info.url         = 'http://addons.eventscripts.com/addons/view/Server_Redirect'
info.description = "Simple plugin where you can annouce your other server and they can connect it!"
info.basename    = "server_redirect"
info.version     = "v1.0"
info.cfgpath     = "add_servers.cfg"
info.cfgpath_2   = "config.cfg"

es.ServerVar('server_redirect', info.version, 'Server Redirect - Made by %s '%info.author).makepublic()

# Config 1
config = cfglib.AddonCFG(es.getAddonPath("server_redirect")+'/configs/add_server.cfg')

# Server Config
config.text("" + info.name + " " + info.version)
config.text(">>>>>>>>>>>>READ<<<<<<<<<<<<")
config.text("If you want to leave something blank write none")
config.text("You must write none else it will display the text anyway.")
config.text("Remember to edit config.cfg just as important!")
config.text("You can edit them again at any time!")
config.text("")
config.text("redirect_1 is not an example so remember to edit that one too!")
config.text("")
config.text("")
redirect_1 = config.cvar("redirect_1", "173.199.71.125:27015", "IP + Port to the server")
redirect_desc_1 = config.cvar("redirect_desc_1", "!propserver", "Chat Command to join the server!")
config.text("----------------------------------------")
redirect_2 = config.cvar("redirect_2", "173.199.69.125:27015")
redirect_desc_2 = config.cvar("redirect_desc_2", "!wcs")
config.text("----------------------------------------")
redirect_3 = config.cvar("redirect_3", "none")
redirect_desc_3 = config.cvar("redirect_desc_3", "none")
config.text("----------------------------------------")
redirect_4 = config.cvar("redirect_4", "none")
redirect_desc_4 = config.cvar("redirect_desc_4", "none")
config.text("----------------------------------------")
redirect_5 = config.cvar("redirect_5", "none")
redirect_desc_5 = config.cvar("redirect_desc_5", "none")
config.text("----------------------------------------")
redirect_6 = config.cvar("redirect_6", "none")
redirect_desc_6 = config.cvar("redirect_desc_6", "none")
config.text("----------------------------------------")
redirect_7 = config.cvar("redirect_7", "none")
redirect_desc_7 = config.cvar("redirect_desc_7", "none")
config.text("----------------------------------------")
redirect_8 = config.cvar("redirect_8", "none")
redirect_desc_8 = config.cvar("redirect_desc_8", "none")
config.text("----------------------------------------")
redirect_9 = config.cvar("redirect_9", "none")
redirect_desc_9 = config.cvar("redirect_desc_9", "none")
config.text("----------------------------------------")
redirect_10 = config.cvar("redirect_10", "none")
redirect_desc_10 = config.cvar("redirect_desc_10", "none")
config.text("----------------------------------------")
config.write()

# COnfig 2
config_source = cfglib.AddonCFG(es.getAddonPath("server_redirect")+'/configs/config.cfg')

# Plugin Config
config_source.text("    " + info.name + " " + info.version)
config_source.text(">>>>>>>>>>READ<<<<<<<<<")
config_source.text("If you want to leave something blank write none")
config_source.text("You must write none if you not going to use them")
config_source.text("You can edit them again at any time!")
config_source.text("")
config_source.text("annouce_server_1 is not a example go and edit it")
config_source.text("")
annouce_server_1 = config_source.cvar("annouce_server_1", "BuildWars | Prop [Fast DL]", "Set your server description that redirect will annouce")
annouce_server_2 = config_source.cvar("annouce_server_2", "Hoejhus | WCS/DM")
annouce_server_3 = config_source.cvar("annouce_server_3", "none")
annouce_server_4 = config_source.cvar("annouce_server_4", "none")
annouce_server_5 = config_source.cvar("annouce_server_5", "none")
annouce_server_6 = config_source.cvar("annouce_server_6", "none")
annouce_server_7 = config_source.cvar("annouce_server_7", "none")
annouce_server_8 = config_source.cvar("annouce_server_8", "none")
annouce_server_9 = config_source.cvar("annouce_server_9", "none")
annouce_server_10 = config_source.cvar("annouce_server_10", "none")
config_source.text("")
config_source.write()

# To be sure, it will be replied in load()
es.makepublic(info.basename)

# If new version
new_version = "v1.2"
#updater = 0
input_date = str(datetime.date.today())

def load():
    # Make sure it's executed
    updater = update_version()
    redirect_prefix('has been loaded!\nYour server is now running Redirect %s' %info.version)
    config.execute()
    es.makepublic(info.basename)
    config_source.execute()
    if updater:
     redirect_prefix("[Redirect] UPDATE: New version available (v1.2)")
     redirect_prefix("[Redirect] UPDATE: Download it at:http://addons.eventscripts.com/addons/view/Server_Redirect")

def unload():
    redirect_prefix('has been unloaded!\nYour server no longer runs Redirect %s' %info.version)


##############################################################################################################################################################
def update_version():
    global new_version
    try:
      redirect_hook = urllib2.urlopen('http://addons.eventscripts.com/addons/view/Server_Redirect')
      version = redirect_hook.readlines()
      redirect_hook.close()
      if new_version in version:
           es.dbgmsg(1, "[%s] - [Redirect] UPDATE: New version available (v1.2)" %input_date)
           es.dbgmsg(1, "[%s] - [Redirect] UPDATE: Download it at:http://addons.eventscripts.com/addons/view/Server_Redirect" %input_date)
           redirect_log_succes = open(es.getAddonPath("server_redirect")+'/logs/log_succes/redirect_succes.log','w')
           redirect_log_succes.write("[%s] - [Redirect] UPDATE: Download it at:http://addons.eventscripts.com/addons/view/Server_Redirect" %input_date)
           redirect_log_succes.write("[%s] - [Redirect] UPDATE: New version available (v1.2)" %input_date)
           return(version)
      else:
         log_succes()
         es.dbgmsg(1, "[%s] - [Redirect] Succesfull: checked for updates, but no updates are available!" %input_date)
    except urllib2.URLError:
        log_error()

def log_error():
      redirect_log_error = open(es.getAddonPath("server_redirect")+'/logs/log_errors/redirect_error.log','w')
      redirect_log_error.write('[%s] - [Redirect] ERROR: Couldn\'t check for updates!\n[Redirect] ERROR: Please check if there a new update to fix this' %input_date)

def log_succes():
      redirect_log_succes = open(es.getAddonPath("server_redirect")+'/logs/log_succes/redirect_succes.log','w')
      redirect_log_succes.write("[%s] - [Redirect] Succesfull: checked for updates, but no updates are available!" %input_date)

def redirect_prefix(text):
     es.msg('#multi', '#green[#lightgreenRedirect#green]#default ' + text)

def redirect_none():
    if redirect_3 == "none":
     es.dbgmsg(1, "[Redirect] Some redirects is disabled, be sure to check!!")
    if annouce_server_3 == "none":
     es.dbgmsg(1, "[Redirect] Some annoucements is disabled, be sure to check!")

def player_say(event_var):
  if event_var['text'] == '%s' %redirect_desc_1:
   if not redirect_1 == "none":
    msglib.VguiDialog(title='%s' %redirect_1, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_1)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_1)

  if event_var['text'] == '%s' %redirect_desc_2:
   if not redirect_2 == "none":
    msglib.VguiDialog(title='%s' %redirect_2, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_2)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_2)

  if event_var['text'] == '%s' %redirect_desc_3:
   if not redirect_3 == "none":
    msglib.VguiDialog(title='%s' %redirect_3, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_3)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_3)

  if event_var['text'] == '%s' %redirect_desc_4:
   if not redirect_4 == "none":
    msglib.VguiDialog(title='%s' %redirect_4, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_4)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_4)

  if event_var['text'] == '%s' %redirect_desc_5:
   if not redirect_5 == "none":
    msglib.VguiDialog(title='%s' %redirect_5, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_5)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_5)

  if event_var['text'] == '%s' %redirect_desc_6:
   if not redirect_6 == "none":
    msglib.VguiDialog(title='%s' %redirect_6, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_6)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_6)

  if event_var['text'] == '%s' %redirect_desc_7:
   if not redirect_7 == "none":
    msglib.VguiDialog(title='%s' %redirect_7, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_7)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_7)

  if event_var['text'] == '%s' %redirect_desc_8:
   if not redirect_8 == "none":
    msglib.VguiDialog(title='%s' %redirect_8, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_8)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_8)

  if event_var['text'] == '%s' %redirect_desc_9:
   if not redirect_9 == "none":
    msglib.VguiDialog(title='%s' %redirect_9, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about connect to #darkgreen%s '%annouce_server_9)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_9)

  if event_var['text'] == '%s' %redirect_desc_10:
   if not redirect_10 == "none":
    msglib.VguiDialog(title='%s' %redirect_10, time=10, mode=msglib.VguiMode.ASKCONNECT).send(event_var['userid'])
    es.playsound(event_var['userid'], 'radio/roger.wav', 1.0)
    redirect_prefix('You are about to connect #darkgreen%s '%annouce_server_10)
   else:
    redirect_prefix('For some reason you could not connect to #darkgreen%s '%annouce_server_10)

def round_start(ev):
    if not annouce_server_1 == "none":
     gamethread.delayed(15, redirect_prefix, '#defaultPlease also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_1, redirect_desc_1))
    if not annouce_server_2 == "none":
     gamethread.delayed(30, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_2, redirect_desc_2))
    if not annouce_server_3 == "none":
     gamethread.delayed(45, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_3, redirect_desc_3))
    if not annouce_server_4 == "none":
     gamethread.delayed(60, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_4, redirect_desc_4))
    if not annouce_server_5 == "none":
     gamethread.delayed(75, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_5, redirect_desc_5))
    if not annouce_server_6 == "none":
     gamethread.delayed(90, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_6, redirect_desc_6))
    if not annouce_server_7 == "none":
     gamethread.delayed(105, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_7, redirect_desc_7))
    if not annouce_server_8 == "none":
     gamethread.delayed(120, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_8, redirect_desc_8))
    if not annouce_server_9 == "none":
     gamethread.delayed(135, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing ( #darkgreen%s#default )'% (annouce_server_9, redirect_desc_9))
    if not annouce_server_10 == "none":
     gamethread.delayed(150, redirect_prefix, '#default- Please also join our #darkgreen%s#default, #defaultby typing (#darkgreen%s#default)'% (annouce_server_10, redirect_desc_10))

def player_activate(ev):
    userid = int(ev['userid'])
    name = es.getplayername(userid)
    redirect_prefix('Welcome #darkgreen%s#default, this server is running Redirect and that allow you to join our other servers!' %name)

# End of version 1.0
